<?

class C_FileArea
{
	var $areatag;
	var $descr;
	var $base;
	var $files_bbs;
	
	function MoveFileToArea($filename,$name,$descr)
	{
		fseek($this->files_bbs,0,SEEK_END);
		$size = filesize($filename);
		rename($filename,$this->base.'/'.$name);
		if ($size > 10*(1 << 30)) { $size = ($size >> 30).'G'; }
		elseif ($size > 10*(1 << 20)) { $size = ($size >> 20).'M'; }
		elseif ($size > 10*(1 << 10)) { $size = ($size >> 10).'K'; }
		fwrite($this->files_bbs,$name.' '.$size.' '.($descr?$descr:'No description')."\n");
	}

	function Open($areaname)
	{
		GLOBAL $CONFIG;
		tolog('U',"Opening area $areaname");
		if (($num = $CONFIG->FAreas->FindAreaNum($areaname))==-1) 
		{ 
			tolog('U',"Area $areaname not found"); 
			return 0; 
		}
		$this->areatag = $CONFIG->FAreas->Vals[$num]->EchoTag;
		$this->descr = (($CONFIG->FAreas->Vals[$num]->Options['-d'])?($CONFIG->FAreas->Vals[$num]->Options['-d']):($CONFIG->FAreas->Vals[$num]->EchoTag));
		$this->base = $CONFIG->FAreas->Vals[$num]->Path;
		if (!is_file($fd=$this->base."/files.bbs")) 
		{ 
			tolog('U',"File $fd not found");
			return 0; 
		}
		$this->files_bbs = fopen($fd,'r+') or die("Could not open $fd");
		return 1;
	}

	function Close()
	{
		tolog('U','Closing area');
		fclose($this->files_bbs);
	}

	function CreateBase($filename)
	{
		tolog('U',"Creating base $filename");
		mkdir($filename);
		chmod($filename,0777);
		$files_bbs = fopen("$filename/files.bbs",'w');
		fclose($files_bbs);
		chmod("$filename/files.bbs",0666);
		tolog('U','Creating finished');
	}

	function SeekAndRead($num)
	{
		fseek($this->files_bbs,0);
		for ($i=$num-1;$i;$i--) { fgets($this->files_bbs,1024); }
		return $this->ReadFileDes();
	}

	function CountFiles()
	{
		fseek($this->files_bbs,0);
		$cnt = 0;
		while ( fgets($this->files_bbs,1024) ) { $cnt++; }
		return $cnt;
	}

	function ReadFileDes()
	{
		$line = fgets($this->files_bbs,1024);
		return split(' ',$line,3);
	}
}
