<?

require_once "ziplib.php";
require_once "F_utils.php";
require_once "F_archives.php";
require_once "C_textdb.php";


function print_ftsc(&$template,$rd,$doc)
{
	function print_ftsc_hat(&$template,$msg,$rd=0)
	{
		$rdcnt = 0;
		foreach (array('Map','FTA','FTS','FSP','FSC','FRL','Products') as $item)
		{
			$template->assign_block_vars('sections',array(
				'URL'		=> formurl('docs','index=ftsc&rd='.$rdcnt),
				'CHECKED'	=> $rdcnt++==$rd,
				'DESCR'		=> $item
			));
		}
	}

	GLOBAL $CONFIG;
	$arch = $CONFIG->GetVar('ftsc_docs').'/';
	if ($doc) {
		if (strstr($doc,'-')) {
			$arch.= strtolower(strtok($doc,'-'));
		} else {
			$arch.= strtolower(strtok($doc,'.'));
		}
		$arch .= '.zip';
		if (is_file($arch)) {
			$Archive = new ZipReader($arch);
			while ($file_data = $Archive->ReadFile()) {
				if (strcasecmp($doc,substr($file_data[0],0,strlen($doc)))==0) {
					$content = $file_data[1];
					$name = $file_data[0];
				}
			}
			$Archive->done();
			if (isset($name) && $name) {
				print_ftsc_hat(&$template,$name,$rd);
				$content = nl2br(htmlspecialchars($content));
				$content = eregi_replace('(((((fts|fsp|frl|fta|fsc)\-[0-9]{4})|(ftscprod))\.[0-9]{3})|((fts|fsp|frl|fta|fsc)\-[0-9]{4}))','<a href='.formurl('docs','index=ftsc&doc=\0').'>\0</a>',$content);
				$template->assign_vars(array(
					'DOCUMENT'	=> $name,
					'CONTENT'	=> $content
				));
				$template->set_filenames(array(
					'body' => 'docs/ftsc.html'
				));
			} else {
				include "I_404.php";
			}
		} else {
			include "I_404.php";
		}
	} else if ($rd) {
		if ($file = fopen($arch.'/descript.ion','r')) {
			$cnt = $cnt2 = 0;
			while ($line = fgets($file,10240)) {
				if (strcmp(substr($line,0,10),'----------')==0) {
					$cnt++;
				}
				if ($cnt==$rd) {
					print_ftsc_hat(&$template,$linec,$rd);
					$template->assign_vars(array(
						'DOCUMENT'	=> $linec
					));
					break;
				}
				$linec = $line;
			}
			$content = '';
			if ($cnt==$rd) {
				while (($line = fgets($file,10240)) && ($cnt2<2)) {
					if (!trim($line)) { 
						$cnt2++; 
					}
					$line = nl2br(htmlspecialchars($line));
					$line = eregi_replace('(((((fts|fsp|frl|fta|fsc)\-[0-9]{4})|(ftscprod))\.[0-9]{3})|((fts|fsp|frl|fta|fsc)\-[0-9]{4}))','<a href='.formurl('docs','index=ftsc&doc=\0').'>\0</a>',$line);
					$content .= $line;
				}
				$template->assign_vars(array(
					'CONTENT'	=> $content
				));
				$template->set_filenames(array(
					'body' => 'docs/ftsc.html'
				));
			} else {
				include "I_404.php";
			}
			fclose($file);
		} else {
			include "I_404.php";
		}
	} else {
		print_ftsc_hat(&$template,'Road Map');
		$template->assign_vars(array(
			'DOCUMENT'	=> 'Road Map'
		));
		$content = '';
		if ($file = fopen($arch.'/roadmap.txt','r')) {
			while ($line = fgets($file,10240)) {
				$line = nl2br(htmlspecialchars($line));
				$line = eregi_replace('((fts|fsp|frl|fta|fsc)\-[0-9]{4})','<a href='.formurl('docs','index=ftsc&doc=\0').'>\0</a>',$line);
				$content .= $line;
			}
			$template->assign_vars(array(
				'CONTENT'	=> $content
			));
			$template->set_filenames(array(
				'body' => 'docs/ftsc.html'
			));
			fclose($file);
		} else {
			include "I_404.php";
		}
	}
}

function display_docs_index($index,&$template)
{
	GLOBAL $db_docs;
	$strings = split("\n",$db_docs->Get());

	$cnt = 0;
	foreach($strings as $str) {
		$str = htmlspecialchars(trim($str));
		if ($str) {
			$template->assign_block_vars('sections',array(
				'CHECKED'	=> (++$cnt)==$index,
				'URL'		=> formurl('docs',strstr($str,'FTSC')?"index=ftsc":("index=$cnt")),
				'DESCR'		=> trim(substr($str,4))
			));
		}
	}
}

function display_docs_num($index,&$template)
{
	function print_docs_num_printone($arr,$index,$i,&$template)
	{
		if ($arr){
			$arr0 = array_shift($arr);
			$arr1 = array_shift($arr);
			$arr2 = array_shift($arr);
			$template->assign_block_vars('documents',array(
				'NAME'		=> str_replace(' ','&nbsp;',$arr2),
				'DESCR'		=> join('<br>',$arr),
				'URL_PLAIN'	=> formurl('docs',"index=$index&doc=".$arr0),
				'URL_ZIP'	=> formurl('docs',"index=$index&act=get&doc=".$arr0)
			));
		}
	}
	
	GLOBAL $db_docs;
		
	fseek($db_docs->file,0);
	$db_docs->SeekToLvl(0,$index);
	while ($line = fgets($db_docs->file,10240)) {
		if (substr($line,0,3) == '---') {
			break;
		} else if (substr($line,0,3) == '***') {
			print_docs_num_printone($arr,$index,++$cnt,$template);
			$arr = array(htmlspecialchars(trim(substr($line,3))));
		} else {
			$line = htmlspecialchars(trim($line));
			if ($line) $arr[] = $line;
		}
	}
	print_docs_num_printone($arr,$index,++$cnt,$template);

}

function print_docs_doc(&$template,$index,$doc,$act)
{
	GLOBAL $db_docs;
	if (preg_match('/[a-z0-9\-]/i',$doc) && is_file($fname = 'docs/'.$doc.'.zip')) {
		if ($act == 'get') {
			send_file_to_brw($fname);
		} else {
			fseek($db_docs->file,0);
			while ($line = fgets($db_docs->file,10240)) {
				if (strcmp(substr($line,0,3),'***')==0) {
					if (trim(substr($line,3)) == $doc) {
						break;
					}
				}
			}
			$enc = htmlspecialchars(trim(fgets($db_docs->file,10240)));
			$name =  htmlspecialchars(trim(fgets($db_docs->file,10240)));
			$descr = htmlspecialchars(trim(fgets($db_docs->file,10240)));
			$content = Get_Content_from_zip($fname);
			$template->assign_vars(array(
				'NAME'		=> $name,
				'DESCR'		=> $descr,
				'CONTENT'	=> htmlspecialchars(convert_to_koi($content,$enc))
			));
			$template->set_filenames(array(
				'body' => 'docs/doc.html'
			));
		}
	} else {
		include "I_404.php";
	}
}

$index = get_http_var('index');
$doc = get_http_var('doc');

$db_docs = new C_TextDB;
$db_docs->Open('doc_b',array('---','***'));

if ($index == 'ftsc') {
	print_ftsc(&$template,get_http_var('rd'),get_http_var('doc'));
} elseif ($doc) {
	print_docs_doc(&$template,$index,$doc,get_http_var('act'));
} else {

	display_docs_index($index,$template);
	if ($index) {
		display_docs_num($index,$template); 
	}

	$template->set_filenames(array(
		'body' => 'docs/main.html'
	));
}

$db_docs->Close();

?>
