<?

require_once "C_textdb.php";

function addlinks_form(&$template)
{
	$template->assign_vars(array(
		'ACTION_URL'	=> formurl('links','action=add')
	));
	
	$template->set_filenames(array(
		'body' => 'links/add.html'
	));
}

function print_links_index(&$template,$index)
{
	GLOBAL $db_links;
	
	$strings = split("\n",$db_links->Get());

	$cnt = 0;
	foreach($strings as $str) {
		$str = htmlspecialchars(trim($str));
		if ($str) {
			$cnt++;
			$template->assign_block_vars('sections',array(
				'CHECKED'	=> $cnt == $index,
				'URL'		=> formurl('links',"index=$cnt"),
				'DESCR'		=> str_replace(' ','&nbsp;',trim(substr($str,4)))
			));
		}
	}	
}

function print_links_num(&$template,$num)
{
	GLOBAL $db_links;

	$newlink = true;
	$item = array();

	$strings = split("\n",$db_links->Get($num));
	
	foreach($strings as $str) {
		$str = htmlspecialchars(trim($str));
		if ($str == '') {
			$newlink = true;
			if ($item !== array()) {
				$template->assign_block_vars('urlsrow',array(
					'URL'	=> $item[0],
					'DESCR'	=> $item[1]
				));
				$item = array();
			}
		} else {
			if ($newlink) {
				$item[0] = $str;
				$newlink = false;
			} else {
				$item[1] .= $str."<br>";
			}
		}
	}

	if ($item !== array()) {
		$template->assign_vars('urlsrow',array(
			'URL'	=> $item[0],
			'DESCR'	=> $item[1]
		));
		$item = false;
	}
}

$index = get_http_var('index');
$action = get_http_var('action');

if ($action == 'add') {
    if ($purl = get_http_post_var('url')) {
		if ($db = fopen('links','a')) {
			$url = trim($purl);
			$des = trim(get_http_post_var('descr'));
			$sta = trim(get_http_post_var('state'));
			fwrite($db,$url."\n".($des?$des."\n":'').($sta?": $sta\n":'')."\n");
			fclose($db);
			$template->assign_vars(array(
				'OPERATION_RESULT'	=> '   ... ;-)'
			));
		} else {
			$template->assign_vars(array(
				'OPERATION_RESULT'	=> '   .  -    . :-(((    fidoweb.local       ...'
			));
		}
		
		$template->set_filenames(array(
			'body' => 'links/postadd.html'
		));
	} else {
		addlinks_form(&$template);
	}
} else {
	$db_links = new C_TextDB;
	$db_links->Open('links',array('***'));

	print_links_index(&$template,$index);
	if ($index) {
		print_links_num(&$template,$index); 
	} 

	$template->assign_vars(array(
		'ADD_LINKS_URL'	=> formurl('links','action=add')
	));
	
	$db_links->Close();

	$template->set_filenames(array(
		'body' => 'links/main.html'
	));
}
	
?>
