<?

require_once "C_msgbase.php";

function display_newslenta(&$template, $echo)
{
	$NewsEcho = new C_htmlreader;
	if ($NewsEcho->Open($echo)) {
		$news_count = $NewsEcho->GetNumMsgs();
		$show_news_count = ($news_count<5?$news_count:5);
		for ($i=0; $i<$show_news_count; $i++) {
			$header = $NewsEcho->ReadMsgHeader($news_count-$i);
			$Msg_body = $NewsEcho->ReadMsgBody($news_count-$i);
			$first_str = getfirstline($Msg_body);
			if (strlen($first_str)>256) { $first_str = substr($first_str,0,254).'...'; }
			
			$template->assign_block_vars('lenta', array(
				'SUBJ'	=> $header->Subj,
				'DESCR'	=> $first_str,
				'URL'	=> formurl('news',"sect=fidonet&letter=".($news_count - $i))
			));
		}
	}
}

function display_nodestat(&$template)
{
	GLOBAL $CONFIG;
	if ($ncu = $CONFIG->GetVar('nodecurrfile')) {
		$f = fopen($ncu,'r');
		list($year,$num_nl) = split(',',chop(fgets($f,16)));
		while ($line = fgets($f,1024)):
			$zone[] = split(';',$line);
		endwhile;
		fclose($f);

		$sz = sizeof($zone);
		$sum = array(0,0,0,0);
		for ($i=1; $i<$sz; $i++) {
			for ($k=2; $k<=5; $k++) {
				$sum[$k-2]+=$zone[$i][$k];
			}
		}

		$template->assign_vars(array(
			'NDL_DAY'		=> $num_nl,
			'NDL_NETS'		=> $sum[1],
			'NDL_NETS_CH'	=> $sum[1]-$sum[0],
			'NDL_NODES'		=> $sum[3],
			'NDL_NODES_CH'	=> $sum[3]-$sum[2],
			'NDL_DIFF_URL'	=> formurl('nodehist',"year=$year&num=$num_nl")
		));

		for ($i=1; $i<$sz; $i++) {
			$template->assign_block_vars('nodestat',array(
				'URL'		=> formurl('nodelist',"addr=$i:$i/0"),
				'DESCR'		=> "Zone $i",
				'LOCATION'	=> $zone[$i][1],
				'NETS'		=> $zone[$i][3],
				'NETS_CH'	=> $zone[$i][3]-$zone[$i][2],
				'NODES'		=> $zone[$i][5],
				'NODES_CH'	=> $zone[$i][5]-$zone[$i][4]
			));

			if ($i==2) {
				$template->assign_block_vars('nodestat',array(
					'URL'		=> formurl('nodelist',"addr=2:50/0"),
					'DESCR'		=> "Region 50",
					'LOCATION'	=> $zone[0][1],
					'NETS'		=> $zone[0][3],
					'NETS_CH'	=> $zone[0][3]-$zone[0][2],
					'NODES'		=> $zone[0][5],
					'NODES_CH'	=> $zone[0][5]-$zone[0][4],
					'IS_REGION'	=> 1
				));
			}
		}
	}
}

function display_topten(&$template)
{
	GLOBAL $CONFIG;
	if (!$CONFIG->GetVar('internet_disallow') &&
	($fp=@fopen("http://www.fido-online.com/_-1/","r"))) {
		$count=-1;
		while ($line=fgets($fp,10240)) {
			if ($count==-1 and 
				(strpos($line, "10 ")>0) or
				(strpos($line, "10 ")>0)) {
				$count=1;
			}
			if ($count>0) {
				$count=$count+1;
			}
			if ($count>4 and $count<18) {
				if (strpos($line, "nowrap")>0) {
					if (preg_match("/<b>([^<>]+)<\/b>.*<small>([^<>]*)<\/small>/",
						$line,$matches)) {
						$template->assign_block_vars('topten',array(
							'TAG'		=> $matches[1],
							'DESCR'		=> $matches[2],
						));
					}
				}
    		}
		}
		fclose($fp);
	}
}

display_newslenta($template, 'fidoweb.news.fidonet');
display_nodestat($template);
display_topten($template);

$template->set_filenames(array(
	'body' => 'main/main.html')
);

?>
