<?

require_once "C_nodestat.php";

function ShowNdiffStats(&$template,$year,$num)
{
	GLOBAL $CONFIG;

	if (strcmp(substr($CONFIG->GetVar('nodestatpath'),0,6),'mysql:')==0):
		$ns = new C_nodestat_mysql;
		$ns->Init(substr($CONFIG->GetVar('nodestatpath'),6));
	else:
		$ns = new C_nodestat;
		$ns->Init($CONFIG->GetVar('nodestatpath'));
	endif;

	$arr = $ns->ReadNdl($year,$num);
	$ns->Done();

	$new = array();
	$del = array();
	$chg = array();
	foreach($arr as $larr):
		switch(array_shift($larr)):
			case('C'):
				$chg[] = $larr;
				break;
			case('D'):
				$del[] = $larr;
				break;
			case('N'):
				$new[] = $larr;
				break;
		endswitch;
	endforeach;

	$template->assign_vars(array(
		'NL_YEAR'		=> $year,
		'NL_NUM'		=> $num,
		'NL_NEW_NODES'	=> sizeof($new),
		'NL_REM_NODES'	=> sizeof($del),
		'NL_CHG_NODES'	=> sizeof($chg)
	));		

	foreach($new as $str) {
		$addr = array_shift($str);
		$template->assign_block_vars('newnodes',array(
			'ADDRESS'	=> $addr,
			'SYSOP'		=> str_replace("_",' ',htmlspecialchars($str[4])),
			'SYSTEM'	=> str_replace("_",' ',htmlspecialchars($str[2])),
			'PLACE'		=> str_replace("_",' ',htmlspecialchars($str[3])),
			'LINE'		=> htmlspecialchars(join(',',$str))
		));
	}
	
	foreach($del as $str) {
		$addr = array_shift($str);
		$template->assign_block_vars('remnodes',array(
			'ADDRESS'	=> $addr,
			'SYSOP'		=> str_replace("_",' ',htmlspecialchars($str[4])),
			'SYSTEM'	=> str_replace("_",' ',htmlspecialchars($str[2])),
			'PLACE'		=> str_replace("_",' ',htmlspecialchars($str[3])),
			'LINE'		=> htmlspecialchars(join(',',$str))
		));
	}

	foreach($chg as $str) {
		$addr = array_shift($str);
		$line = '';
		$c = 0;
		$na = array();
		foreach($str as $it) {
			if ($c!=0) $line.= ',';
			if (($p=strpos($it,';'))===false):
				$line.= $it;
				$na[$c] = false;
				$nn[$c] = $it;
			else:
				$na[$c] = split(';',$it);
				$nn[$c] = $na[$c][1];
			endif;
			$c++;
		}

		$template->assign_block_vars('chgnodes',array(
			'ADDRESS'	=> $addr,
			'SYSOP'		=> str_replace("_",' ',htmlspecialchars($nn[4])),
			'SYSTEM'	=> str_replace("_",' ',htmlspecialchars($nn[2])),
			'PLACE'		=> str_replace("_",' ',htmlspecialchars($nn[3])),
			'LINE'		=> htmlspecialchars(join(',',$nn)),
		));

		$plarr = array('Node status','Node number','Station name','Location','Sysop name','Telephone number','Baudrate','Flags');
		for($c=0;$c<8;$c++) {
			if ($na[$c]!==false) {
				$template->assign_block_vars('chgnodes.changes',array(
					'WHAT'	=> $plarr[$c],
					'OLD'	=> htmlspecialchars(($na[$c][0])?($na[$c][0]):'<none>'),
					'NEW'	=> htmlspecialchars(($na[$c][1])?($na[$c][1]):'<none>')
				));
			}
		}
	}
	$template->set_filenames(array(
		'body' => 'nl/diff.html')
	);
}

/*function ShowNodeStats($node)
{
	GLOBAL $CONFIG;

	if (strcmp(substr($CONFIG->GetVar('nodestatpath'),0,6),'mysql:')==0):
		$ns = new C_nodestat_mysql;
		$ns->Init(substr($CONFIG->GetVar('nodestatpath'),6));
	else:
		$ns = new C_nodestat;
		$ns->Init($CONFIG->GetVar('nodestatpath'));
	endif;

	$arr = $ns->ReadNode($node);
	$ns->Done();

prints ('<table width="100%" cellspacing="0" cellpadding="0" border="0" valign="top"><tr>
<td width="100%" class="center_frame_title">    '.$node.'</td>
</tr><td width="100%" class="frame_text">
<center><b>    '.$node.':</b></center><br>');

if (sizeof($arr)==0):
	prints('<center>&lt;...      ...&gt;</center><br>');
else:
foreach($arr as $str):
	$ndl = array_shift($str);
	$year = substr($ndl,0,4);
	$num = substr($ndl,4,3);
	$st = array_shift($str);
	$addr = array_shift($str);
	$line = '';
	$c = 0;
	$na = array();
	if (strcmp($st,'C')==0):
		foreach($str as $it):
			if ($c!=0) $line.= ',';
			if (($p=strpos($it,';'))===false):
				$line.= $it;
				$na[$c] = false;
				$nn[$c] = $it;
			else:
				$na[$c] = split(';',$it);
				$nn[$c] = $na[$c][1];
			endif;
			$c++;
		endforeach;
	else:
		foreach($str as $it):
			$nn[$c] = $it;
			$c++;
		endforeach;
	endif;
	prints("<b>$num-  $year </b> (Sysop: ".
		str_replace("_",' ',htmlspecialchars($nn[4])).
		", name: ".
		str_replace("_",' ',htmlspecialchars($nn[2])).
		", location: ".
		str_replace("_",' ',htmlspecialchars($nn[3])).
		")<br>");
	prints('<font color="Gray">'.htmlspecialchars(join(',',$nn)).'</font><br>');
	$plarr = array('Node status','Node number','Station name','Location','Sysop name','Telephone number','Baudrate','Flags');
	switch($st):
		case('N'):
			prints('&nbsp;&nbsp;Node added to the nodelist<br>');
			break;
		case('C'):
			for($c=0;$c<8;$c++):
				if ($na[$c]!==false)
					prints('&nbsp;&nbsp;'.htmlspecialchars($plarr[$c].' changed: '.(($na[$c][0])?("\"".$na[$c][0]."\""):'<none>').' ==> '.(($na[$c][1])?("\"".$na[$c][1]."\""):'<none>'))."<br>");
			endfor;
			break;
		case('D'):
			prints('&nbsp;&nbsp;Node removed from the nodelist<br>');
			break;
	endswitch;
	prints('<br>');
endforeach;
endif;

prints('</td></tr></table>');

}
*/
$year = get_http_var('year');
$num = get_http_var('num');
$node = get_http_var('node');

#if ($node):
#	ShowNodeStats($node);
#else
if ($year && $num):
	ShowNdiffStats(&$template,$year,$num);
else:
	include "I_404.php";
endif;

?>
