<?

function decode_time($ttime)
{
	STATIC $mas;
	if (!$mas) {
		$mas=array(
 
'A' => '00:00'  ,  'F' => '05:00'  ,  'K' => '10:00'  ,  'P' => '15:00'  ,  'U' => '20:00',
'a' => '00:30'  ,  'f' => '05:30'  ,  'k' => '10:30'  ,  'p' => '15:30'  ,  'u' => '20:30',
'B' => '01:00'  ,  'G' => '06:00'  ,  'L' => '11:00'  ,  'Q' => '16:00'  ,  'V' => '21:00',
'b' => '01:30'  ,  'g' => '06:30'  ,  'l' => '11:30'  ,  'q' => '16:30'  ,  'v' => '21:30',
'C' => '02:00'  ,  'H' => '07:00'  ,  'M' => '12:00'  ,  'R' => '17:00'  ,  'W' => '22:00',
'c' => '02:30'  ,  'h' => '07:30'  ,  'm' => '12:30'  ,  'r' => '17:30'  ,  'w' => '22:30',
'D' => '03:00'  ,  'I' => '08:00'  ,  'N' => '13:00'  ,  'S' => '18:00'  ,  'X' => '23:00',
'd' => '03:30'  ,  'i' => '08:30'  ,  'n' => '13:30'  ,  's' => '18:30'  ,  'x' => '23:30',
'E' => '04:00'  ,  'J' => '09:00'  ,  'O' => '14:00'  ,  'T' => '19:00'  ,          
'e' => '04:30'  ,  'j' => '09:30'  ,  'o' => '14:30'  ,  't' => '19:30'  );
	}
	
	return $mas[$ttime];
}

function translate_flag($flag)
{
 if (strcasecmp($flag[0],'t')==0):
  return "Work time: ".decode_time($flag[1])." - ".decode_time($flag[2])." UTC";
 elseif (strcasecmp($flag,'cm')==0):
  return "Node working CM (24 hours per day)";
 elseif (strcasecmp($flag,'mo')==0):
  return "Node haven't BBS (mail-only)";
 elseif (strcasecmp($flag,'lo')==0):
  return "Node accept mail from listed systems only";
 elseif (strcasecmp($flag,'icm')==0):
  return "Node accepts 24/24 IP-mail";
 elseif (strcasecmp($flag,'v22')==0):
  return "ITU-T V22, 1200 bps full duplex";
 elseif (strcasecmp($flag,'v29')==0):
  return "ITU-T V29, 9600 bps half duplex";
 elseif (strcasecmp($flag,'v32')==0):
  return "ITU-T V32, 9600 bps full duplex";
 elseif (strcasecmp($flag,'v32b')==0):
  return "ITU-T V32bis, 14400 bps full duplex";
 elseif (strcasecmp($flag,'v34')==0):
  return "ITU-T V34, 33600 bps full duplex";
 elseif (strcasecmp($flag,'v42')==0):
  return "LAP-M error correction w/fallback to MNP 1-4";
 elseif (strcasecmp($flag,'v42b')==0):
  return "LAP-M error correction w/fallback to MNP 1-5";
 elseif (strcasecmp($flag,'mnp')==0):
  return "Microcom Networking Protocol error correction";
 elseif (strcasecmp($flag,'h96')==0):
  return "Hayes V9600";
 elseif (strcasecmp($flag,'hst')==0):
  return "USR Courier HST";
 elseif (strcasecmp($flag,'h14')==0):
  return "USR Courier HST up to 14.4Kbps";
 elseif (strcasecmp($flag,'h16')==0):
  return "USR Courier HST up to 16.8Kbps";
 elseif (strcasecmp($flag,'max')==0):
  return "Microcom AX/96xx series";
 elseif (strcasecmp($flag,'pep')==0):
  return "Packet Ensemble Protocol";
 elseif (strcasecmp($flag,'csp')==0):
  return "Compucom Speedmodem";
 elseif (strcasecmp($flag,'v32t')==0):
  return "V.32 Terbo mode (implies V.32Bis)";
 elseif (strcasecmp($flag,'vfc')==0):
  return "Rockwell's V.Fast Class";
 elseif (strcasecmp($flag,'zyx')==0):
  return "Zyxel 16.8 Kbps (implies V.32Bis & V.42Bis)";
 elseif (strcasecmp($flag,'v90c')==0):
  return "ITU-T V.90 modem Client";
 elseif (strcasecmp($flag,'v90s')==0):
  return "ITU-T V.90 Server";
 elseif (strcasecmp($flag,'x2c')==0):
  return "US Robotics x2 client";
 elseif (strcasecmp($flag,'x2s')==0):
  return "US Robotics x2 server";
 elseif (strcasecmp($flag,'z19')==0):
  return "Zyxel 19.2 Kbps (implies V.32Bis & V.42Bis & ZYX)";
 elseif (strcasecmp($flag,'mn')==0):
  return "No compression supported";
 elseif (strcasecmp($flag,'xa')==0):
  return "Mailer has XA type";
 elseif (strcasecmp($flag,'xb')==0):
  return "Mailer has XB type";
 elseif (strcasecmp($flag,'xc')==0):
  return "Mailer has XC type";
 elseif (strcasecmp($flag,'xp')==0):
  return "Mailer has XP type";
 elseif (strcasecmp($flag,'xr')==0):
  return "Mailer has XR type";
 elseif (strcasecmp($flag,'xw')==0):
  return "Mailer has XW type";
 elseif (strcasecmp($flag,'xx')==0):
  return "Mailer has XX type";
 elseif (strcasecmp($flag,'#01')==0):
  return "Node accepts zone 5 mail hour";
 elseif (strcasecmp($flag,'#02')==0):
  return "Node accepts zone 2 mail hour";
 elseif (strcasecmp($flag,'#08')==0):
  return "Node accepts zone 4 mail hour";
 elseif (strcasecmp($flag,'#09')==0):
  return "Node accepts zone 1 mail hour";
 elseif (strcasecmp($flag,'#18')==0):
  return "Node accepts zone 3 mail hour";
 elseif (strcasecmp($flag,'#20')==0):
  return "Node accepts zone 6 mail hour";
 elseif (strcasecmp($flag,'ibn')==0):
  return "BinkP protocol";
 elseif (strcasecmp($flag,'ifc')==0):
  return "Raw protocol as used by ifcico";
 elseif (strcasecmp($flag,'ift')==0):
  return "Allow FTP";
 elseif (strcasecmp($flag,'itn')==0):
  return "Telnet protocol";
 elseif (strcasecmp($flag,'ivm')==0):
  return "Vmodem protocol";
 elseif (strcasecmp($flag,'ip')==0):
  return "IP-node";
 elseif (strcasecmp($flag,'imi')==0):
  return "Mime encoded email";
 elseif (strcasecmp($flag,'ise')==0):
  return "SEAT encoded email";
 elseif (strcasecmp($flag,'itx')==0):
  return "TransX compatible email";
 elseif (strcasecmp($flag,'iuc')==0):
  return "UUencoded email";
 elseif (strcasecmp($flag,'iem')==0):
  return "Email node";
 elseif (strcasecmp($flag,'evy')==0):
  return "Voyager-compatible";
 elseif (strcasecmp($flag,'ema')==0):
  return "Email node";
 elseif (strcasecmp($flag,'isdn')==0):
  return "ISDN node";
 elseif (strcasecmp($flag,'v110l')==0):
  return "ITU-T V.110 19k2 async ('low').";
 elseif (strcasecmp($flag,'v110h')==0):
  return "ITU-T V.110 38k4 async ('high').";
 elseif (strcasecmp($flag,'v120l')==0):
  return "ITU-T V.120 56k async, layer 2 framesize 259, window 7, modulo 8.";
 elseif (strcasecmp($flag,'v120h')==0):
  return "ITU-T V.120 64k async, layer 2 framesize 259, window 7, modulo 8.";
 elseif (strcasecmp($flag,'x75')==0):
  return "ITU-T X.75 SLP (single link procedure) with 64kbit/s B channel";
 elseif (strcasecmp($flag,'u')==0):
  return "User flags:";
 elseif (strcasecmp($flag,'ping')==0):
  return "Node accept PING";
 elseif (strcasecmp($flag,'nc')==0):
  return "Network Coordinator";
 elseif (strcasecmp($flag,'rec')==0):
  return "Regional EchoMail Coordinator";
 elseif (strcasecmp($flag,'nec')==0):
  return "Network EchoMail coordinator";
 elseif (strcasecmp($flag,'rc')==0):
  return "Region Coordinator";
 elseif (strcasecmp($flag,'rpk')==0):
  return "Regional Pointlist Keeper";
 elseif (strcasecmp($flag,'npk')==0):
  return "Net Pointlist Keeper";
 elseif (strcasecmp($flag,'enc')==0):
  return "The node accepts inbound encrypted mail";
 elseif (strcasecmp($flag,'cdp')==0):
  return "CD-Point capable (i.e. automatic point creation)";
 elseif (strcasecmp($flag,'sds')==0):
  return "Software Distribution System";
 elseif (strcasecmp($flag,'smh')==0):
  return "Secure Mail Hub";
 elseif (strcasecmp($flag,'k12')==0):
  return "System offering the full range of educational K12-conferences.";
 else:
  return "Flag \"$flag\" is unknown";
 endif;
}

function nl_makeaddr($addr)
{
	for($i=0; $i<=5; $i++) {
		if (!isset($addr[$i]) || $addr[$i] == 65535) $addr[$i] = false;
	}
	if ($addr[0] !== false) { // zone
		$result = $addr[0];
	} else {
		$result = '0';
	}
	$result .= ':';
	if ($addr[2] !== false) { // net
		$result .= $addr[2];
	} else if ($addr[1] !== false) { // region
		$result .= $addr[1];
	} else if ($addr[0] !== false) { // zone
		$result .= $addr[0];
	} else {
		$result .= '0';
	}
	$result .= '/';
	if ($addr[4] !== false) { // node
		$result .= $addr[4];
	} else if ($addr[3] !== false) { // hub
		$result .= $addr[3];
	} else {
		$result .= '0';
	}
	if ($addr[5] !== false) { // point
		$result .= '.'.$addr[5];
	}
	return $result;
}

function nl_writenodelist($cpos,&$template,&$nl,$level,$expand,$address = array(), $reallevel = 0)
{
	foreach($nl->get_sub_list($cpos) as $arr) {
		if ($arr[0] != 65535) $line = split(',',$nl->get_nl_line($arr[2]));
		if ($arr[0] != 65535) $address[$level] = $arr[0];
		$exp = $expand[$level] == $arr[0] || $arr[0] == 65535;
		if ($arr[0] != 65535) {
			$template->assign_block_vars('tree',array(
				'LEVEL'		=> $reallevel+1,
				'RELEVEL'	=> 6-$reallevel,
				'URL'		=> formurl('nodelist',"addr=".nl_makeaddr($address)),
				'LISTED'	=> $exp,
				'STATUS'	=> ($line[0]?
					(strcasecmp($line[0],'host')==0?'Net':$line[0]):
					'Node'),
				'NUMBER'	=> $arr[0],
				'ADDRESS'	=> nl_makeaddr($address),
				'STATION'	=> $line[2]
			));
		}
		if ($exp) {
			nl_writenodelist(
				$arr[1], &$template, &$nl, $level+1, &$expand,
				$address, ($arr[0]==65535?$reallevel:$reallevel+1)
			);
		}
	}
}

function nl_writeinfo(&$template,$addr,&$nl)
{
	$pos = $nl->seek_to_addr(&$addr);
	$arr = $nl->get_node_record($pos);
	$stats = $nl->get_stats($pos);
	$line = $nl->get_nl_line($arr[4]);
	$line = str_replace('_',' ',$line);

	$arr = split(',',rtrim($line));
	$status = array_shift($arr);
	$num = array_shift($arr);
	$name = array_shift($arr);
	$place = array_shift($arr);
	$sysop = array_shift($arr);
	$phone = array_shift($arr);
	$modem = array_shift($arr);
	$flags = &$arr;
	unset($arr);

	$address = nl_makeaddr(&$addr);

	if ($address == '0:0/0') {
		$template->assign_vars(array(
			'NODELIST_MAIN'	=> 1
		));
	
		$status_arr = array(false,'Zones','Regions','Networks','Hubs','Nodes','Points');
		foreach($stats as $what=>$num) {
			$template->assign_block_vars('stats',array(
				'WHAT'	=> $status_arr[$what],
				'NUM'	=> $num
			));
		}
	} else {
		if ($addr[5] === false && $addr[4] === false && $addr[3] === false) {
			$template->assign_vars(array(
				'AREA_STATUS'	=> strcasecmp($status,'host')==0?'Net':$status,
				'AREA_ADDRESS'	=> $address
			));
		
			$status_arr = array(false,'Zones','Regions','Networks','Hubs','Nodes','Points');
			foreach($stats as $what=>$num) {
				$template->assign_block_vars('stats',array(
					'WHAT'	=> $status_arr[$what],
					'NUM'	=> $num
				));
			}
		}

		$template->assign_vars(array(
			'INFO_STATUS'	=> $status==''?'Node':$status,
			'INFO_ADDRESS'	=> $address,
			'INFO_SYSOP'	=> $sysop,
			'INFO_STATION'	=> $name,
			'INFO_LOCATION'	=> $place,
			'INFO_TEL'		=> $phone,
			'INFO_SPEED'	=> $modem
		));
		
		foreach($flags as $flag) {
			$template->assign_block_vars('flags',array(
				'FLAG'	=> translate_flag($flag)
			));
		}
	}
}

function nl_shift_address(&$address)
{
	if ($address[3] != 0) {
		$address[3] = 0;
	} else if ($address[2] != 0) {
		$address[2] = 0;
	} else if ($address[1] != 0) {
		$address[1] = 0;
	} else if ($address[0] != 0) {
		$address[0] = 0;
	} else {
		return false;
	}
	return true;
}

function show_nodelist(&$template)
{
	include_once "C_viewnl.php";

	GLOBAL $CONFIG;
	$nodelist_dir = $CONFIG->GetVar('nodelistpath');
	$nodelist_idx = $CONFIG->GetVar('nodelistidx');
	if ($dir = opendir($nodelist_dir)) {
		while ($fname = readdir($dir)) {
			if (preg_match('/^nodelist\.[0-9]{3}$/i',$fname)) { 
				$nodelist_filename=$nodelist_dir.'/'.$fname;
				$nodelist_day = substr($fname,strrpos($fname,'.')+1);
			}
		}
		closedir($dir);
	}

	if (is_readable($nodelist_idx) && 
			isset($nodelist_filename)) {
		$address = get_http_var("addr");

		$nodelist = new C_viewnl(
			$nodelist_filename,
			$nodelist_idx
		);
		$template->assign_vars(array(
			'TREE_BASEURL'	=> formurl('nodelist')
		));
		if (preg_match("/^(\d+):(\d+)\/(\d+)(\.(\d+))?$/",$address,$match)) {
			$address = array($match[1],$match[2],$match[3],
				isset($match[5])?$match[5]:0);
			while (($arr = $nodelist->find_node($address)) === false &&
				nl_shift_address(&$address));
			nl_writenodelist(0,&$template,&$nodelist,0,$arr);
			nl_writeinfo(&$template,$arr,&$nodelist);
		} else {
			nl_writenodelist(0,&$template,&$nodelist,0,false);
			nl_writeinfo(&$template,false,&$nodelist);
		}
		$template->assign_vars(array(
			'NODELIST_URL'	=> formurl('nodelist','act=get'),
			'NODELIST_DAY'	=> $nodelist_day
		));
	} else {
		$template->assign_vars(array(
			'NL_NA'	=> 1
		));
	}
	
	$template->set_filenames(array(
		'body' => 'nl/main.html'
	));
}

function send_nodelist()
{
	GLOBAL $CONFIG, $SRC_DIR;

	$nodelist_dir = $CONFIG->GetVar('nodelistpath');
	if ($dir = opendir($nodelist_dir)) {
		while ($fname = readdir($dir)) {
			if (preg_match('/^nodelist\.[0-9]{3}$/i',$fname)) { 
				$nodelist_filename=$nodelist_dir.'/'.$fname;
				$nodelist_day = substr($fname,strrpos($fname,'.')+1);
			}
		}
		closedir($dir);
	}

	if (isset($nodelist_filename)) {
		include_once "ziplib.php";
		$Zip = new ZipToBrowser('',"nodelist.zip");
		$Zip->addRegularFile('nodelist.'.$nodelist_day,file_get_contents($nodelist_filename));
		$Zip->finish();
	} else {
		 include $SRC_DIR."I_404.php";
	}
}

if (get_http_var('act') == 'get') {
	send_nodelist();
} else {
	show_nodelist(&$template);
}

?>
