<?

require_once "C_textdb.php";

function print_soft_index(&$template,$index)
{
	GLOBAL $db_softw;
	
	$strings = split("\n",$db_softw->Get());

	$cnt = 0;
	foreach($strings as $str) {
		$str = htmlspecialchars(trim($str));
		if ($str) {
			$cnt++;
			$template->assign_block_vars('sections',array(
				'CHECKED'	=> $cnt == $index,
				'URL'		=> formurl('soft',"index=$cnt"),
				'DESCR'		=> str_replace(' ','&nbsp;',trim(substr($str,4)))
			));
		}
	}	
}

function print_soft_num(&$template,$index)
{
	GLOBAL $db_softw;
	
	$strings = split("\n",$db_softw->Get(array($index)));
	$cnt = 0;

	foreach($strings as $str) {
	$str = htmlspecialchars(trim($str));
		if ($str) {
			++$cnt;
			$template->assign_block_vars('soft',array(
				'URL'   => formurl('soft',"index=$index&prog=$cnt"),
				'NAME'	=> trim(substr($str,4))
			));
		}
	}
}

function print_soft_prog(&$template,$index,$prog)
{
	GLOBAL $db_softw;
	$content = nl2br(htmlspecialchars($db_softw->Get(array($index,$prog))));
	$content = eregi_replace('(http|ftp|https)://[a-z0-9\./_\-]+','<a href="\0">\0</a>',$content);	
	$template->assign_vars(array(
		'CONTENT'	=> $content
	));
	
	$template->set_filenames(array(
		'body' => 'soft/prog.html'
	));
}

$index = get_http_var('index');
$prog = get_http_var('prog');

$db_softw = new C_TextDB;
$db_softw->Open('softw',array('---','***'));

if ($prog) {
	print_soft_prog(&$template,$index,$prog);
} else {
	print_soft_index(&$template,$index);
    if ($index) {
		print_soft_num(&$template,$index);
	}

    $template->set_filenames(array(
		'body' => 'soft/main.html'
	));
}

$db_softw->Close();

?>
