<?

require_once "C_fareas.php";

function send_file_in_area(&$template,$area,$file)
{
	GLOBAL $CONFIG, $Nosend_Tobrw;
	$FArea = new C_FileArea;
	if ($FArea->Open($area)) {
		$filename = $FArea->base.'/'.$file;
		if (is_file($filename)) {
			$Nosend_Tobrw = 1;
			if ($CONFIG->GetVar('manual_headers')) {
				print("Content-type: application/x-force-download; name=\"".$file."\"\r\n");
				print("Content-Disposition: attachment; filename=".$file."\r\n");
				print("Content-Length: ".filesize($filename)."\r\n");
				print("\r\n");
			} else {
				header('Content-type: application/x-force-download; name="'.$file.'"');
				header('Content-Disposition: attachment; filename='.$file);
				header('Content-Length: '.filesize($filename));
			}
			readfile($filename);
		} else {
			include "I_404.php";
		}
		$FArea->Close();
	} else {
		include "I_404.php";
	}
}

function get_fileareas_num_sorted()
{
	GLOBAL $CONFIG;
	$s = sizeof($CONFIG->FAreas->Vals);
	for($i=0;$i<$s;$i++):
		$massiv[$CONFIG->FAreas->Vals[$i]->EchoTag] = $i;
	endfor;
	ksort($massiv);
	return array_values($massiv);
}

function showfileareas(&$template,$start = '')
{
	GLOBAL $CONFIG;

	if ($CONFIG->FAreas->Vals) {
		$areas_sorted = get_fileareas_num_sorted();
		if (!$start) {
			$start=1;
		}
		$fpp = $CONFIG->GetVar('fileareasperpage');
		if (!$fpp) $fpp = 50;
		$areas_end = min($fpp+$start-1,sizeof($areas_sorted));

		for ($i=$start;$i<=$areas_end;$i++) {
			if (!isset($areas_sorted[$i-1])) break;
			$area = $CONFIG->FAreas->Vals[$areas_sorted[$i-1]];
			$Area = new C_FileArea;
			if ($Area->Open($area->EchoTag)) {
				if ($files = $Area->CountFiles()) {
					$template->assign_block_vars('areas',array(
						'NUM'	=> $i,
						'URL'	=> formurl('fecho',"area={$Area->areatag}"),
						'TAG'	=> $Area->areatag,
						'FILES'	=> $files,
						'DESCR'	=> convert_cyr_string($Area->descr,'d','k')
					));
				} else {
					$template->assign_block_vars('areas',array(
						'NUM'	=> $i,
						'URL'	=> formurl('fecho',"area={$Area->areatag}"),
						'TAG'	=> $Area->areatag,
						'FILES'	=> 0,
						'DESCR'	=> convert_cyr_string($Area->descr,'d','k')
					));
				}
				$Area->Close();
			} else {
				$template->assign_block_vars('areas',array(
					'NUM'	=> $i,
					'URL'	=> formurl('fecho',"area={$area->EchoTag}"),
					'TAG'	=> $area->EchoTag,
					'FILES'	=> 0,
					'DESCR'	=> convert_cyr_string(isset($area->Options['-d'])?$area->Options['-d']:$area->EchoTag,'d','k')
				));
			}
		}
	}
    
	$template->assign_vars(array(
		'PAGER_WHAT'	=> 'Areas'
	));
	
	$size_ms = sizeof($areas_sorted)+1;
	for ($i=1;$i<$size_ms;$i+=$fpp) {
		$max = min($size_ms-1,$i+$fpp-1);
		if ($i == $start) {
			$template->assign_block_vars('pager',array(
				'FROM'	=> $i,
				'TO'	=> $max
			));
		} else {
			$template->assign_block_vars('pager',array(
				'FROM'	=> $i,
				'TO'	=> $max,
				'URL'	=> formurl('fecho',"start=$i")
			));
		}
	}

	$template->set_filenames(array(
		'body' => 'fecho/main.html')
	);
}

function sort_fecho_files($arr1,$arr2)
{
	return strcasecmp($arr1[0],$arr2[0]);
}

function showfarea(&$template,$area,$start)
{
	GLOBAL $CONFIG;
	$Area = new C_FileArea;
	if ($Area->Open($area)) {
		$files_num = $Area->CountFiles();
		$FILES[] = $Area->SeekAndRead(1);
		for ($i=1;$i<$files_num;$i++) {
			$FILES[] = $Area->ReadFileDes();
		}
		usort($FILES,'sort_fecho_files');
		$template->assign_vars(array(
			"FECHO_DESCR"	=> convert_cyr_string($Area->descr,'d','k'),
			"FECHO_TAG"		=> $Area->areatag
		));
		
		$fpp = $CONFIG->GetVar('filesperpage');
		if (!$fpp) $fpp = 20;
		if (!$start) $start=1;
		$files_end = min($fpp+$start-1,$files_num);
		for ($i=$start;$i<=$files_end;$i++) {
			list($fname,$size,$descr) = $FILES[$i-1];
			$template->assign_block_vars('files',array(
				'NUM'	=> $i,
				'FNAME'	=> $fname,
				'URL'	=> formurl('fecho',"area=$area&file=".urlencode($fname)),
				'DESCR'	=> convert_cyr_string($descr,'d','k'),
				'SIZE'	=> $size
			));
		}

		$template->assign_vars(array(
			'PAGER_WHAT'	=> 'Files'
		));
		
		$size_ms = sizeof($areas_sorted)+1;
		for ($i=1;$i<$files_num+1;$i+=$fpp) {
			$max = min($files_num,$i+$fpp-1);
			if ($i == $start) {
				$template->assign_block_vars('pager',array(
					'FROM'	=> $i,
					'TO'	=> $max
				));
			} else {
				$template->assign_block_vars('pager',array(
					'FROM'	=> $i,
					'TO'	=> $max,
					'URL'	=> formurl('fecho',"area=$area&start=$i")
				));
			}
		}
		
		$template->set_filenames(array(
			'body' => 'fecho/fecho.html')
		);
	} else {
		if (($num = $CONFIG->FAreas->FindAreaNum($area)) != -1) {
			$template->assign_vars(array(
				"FECHO_DESCR"	=> convert_cyr_string(isset($CONFIG->FAreas->Vals[$num]->Options['-d'])?$CONFIG->FAreas->Vals[$num]->Options['-d']:$CONFIG->FAreas->Vals[$num]->EchoTag,'d','k'),
				"FECHO_TAG"		=> $CONFIG->FAreas->Vals[$num]->EchoTag
			));
			$template->set_filenames(array(
				'body' => 'fecho/fecho.html')
			);
		} else {
			include "I_404.php";
		}
	}
}

$area = get_http_var('area');
$start = get_http_var('start');
$file = urldecode(get_http_var('file'));

if ($file) {
	send_file_in_area(&$template,$area,$file);
} else if ($area !== '') {
	showfarea(&$template,$area,$start);
} else {
	showfileareas(&$template);
}

?>
