<?

require_once "C_msgbase.php";

function printlistinarea(&$template,$Tag,$toblock)
{
	$NewsEcho = new C_htmlreader;
	
	if ($NewsEcho->Open('fidoweb.news.'.$Tag)) {
		$news_count = $NewsEcho->GetNumMsgs();
		$show_news_count = ($news_count<10?$news_count:10);
		
		for ($i=0;$i<=$show_news_count-1;$i++) {
			$header = $NewsEcho->ReadMsgHeader($news_count-$i);
			$Msg_body = $NewsEcho->ReadMsgBody($news_count-$i);
			$first_str = getfirstline($Msg_body);

			if (strlen($first_str)>256) { 
				$first_str = substr($first_str,0,254).'...'; 
			}

	
			$template->assign_block_vars($toblock,array(
				'SUBJ'	=> $header->Subj,
				'DESCR'	=> $first_str,
				'URL'	=> formurl('news',"sect=$Tag&letter=".($news_count-$i))
			));
		}
		$NewsEcho->Close();
	}
}

function printlist(&$template)
{
	printlistinarea(&$template,'fidonet','fidonews');
	printlistinarea(&$template,'project','projnews');
	
	$template->set_filenames(array(
		'body' => 'news/main.html'
	));
}

function printlet(&$template,$sect,$letter)
{
	$Area = new C_htmlreader;
	
	if ($Area->Open('fidoweb.news.'.$sect)) {
		$header = $Area->ReadMsgHeader($letter);
		
		$message = str_replace(chr(13),' '.chr(13),$Area->ReadMsgBody($letter));
		$line = strtok($message,chr(13));
		$content = '';
		
		while ($line) {
			if (!preg_match('/^(( \* )|(---)|(seen-by:)|(\x01))/i',$line)) {
				$content .= $line.'<br>';
			}
			$line = strtok(chr(13));
		}
		$Area->Close();

		$template->assign_vars(array(
			'DESCRIPTION'	=> $header->Subj,
			'CONTENT'		=> $content,
		));
	
		$template->set_filenames(array(
			'body' => 'news/lett.html'
		));
	} else {
		include "I_404.php";
	}
}

$letter = get_http_var("letter");
$sect = get_http_var("sect");

if ($letter && $sect) {
	printlet(&$template,$sect,$letter);
} else {
	printlist(&$template);
}

?>
